#define MYAPI __device__
#include "foo.h"
#include <stdio.h>

__global__ void testkernel(float *r) 
{ 
    int idx = threadIdx.x; 
    if (idx<100) 
        r[idx] = foo((float)idx);
}

int main(int argc, char* argv[])
{ 
    float h_out[100];
    float *d_in;
    cudaMalloc((void**)&d_in, sizeof(float)*100);
    testkernel<<<1, 100>>>(d_in);

    cudaThreadSynchronize();
    if (cudaSuccess == cudaGetLastError())
    {
        printf("Kernel Success\n");
    }
    else
    {
        printf("Kernel Failed\n");
    }

    cudaMemcpy(&h_out, d_in, sizeof(float)*100, cudaMemcpyDeviceToHost);

    for (int k=0; k<100; k++) 
        printf("%f\n", h_out[k]);
}